package net.sf.itcb.addons.monitoring.track.soap;

import java.io.StringWriter;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;

import org.springframework.ws.soap.SoapMessage;

/**
	 * An inner class which aim is to hold the soapRequest in order to be printed in asynchronous method track
	 * Extends exception only 
	 * @author Pierre Le Roux
	 * 
	 */
	public class SoapRequestToString extends Exception{

		private static final long serialVersionUID = 1L;
		
		private static final TransformerFactory transformerFactory = TransformerFactory.newInstance();
		
		private SoapMessage soapMessage;
		
		public SoapRequestToString (SoapMessage soapMessage) {
			this.soapMessage = soapMessage;
		}
		
		@Override
		public String toString() {
			Transformer transformer;
			try {
				transformer = transformerFactory.newTransformer();

				transformer.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
				transformer.setOutputProperty(OutputKeys.INDENT, "no");

				StringWriter writer = new StringWriter();
				transformer.transform(soapMessage.getEnvelope().getSource(), new StreamResult(writer));
				return writer.toString();
			} catch (Exception e) {
				e.printStackTrace();
				return "Error in soapmessage toString";
			}
			 
		}

		@Override
		public String getMessage() {
			return toString();
		}
	}
